Crystal::Macros::HashLiteral -

# class Crystal::Macros::HashLiteral

- Crystal::Macros::HashLiteral
- Crystal::Macros::ASTNode
- Reference
- Object

## Overview

A hash literal.

## Defined in:

## Instance Method Summary

- #[](key : ASTNode) : ASTNode

  Similar to `Hash#[]`

- #[]=(key : ASTNode) : ASTNode

  Similar to `Hash#[]=`

- #clear : HashLiteral

  Similar to `Hash#clear`

- #double_splat(trailing_string : StringLiteral = nil) : MacroId

  Returns a `MacroId` with all of this hash elements joined by commas.

- #empty? : BoolLiteral

  Similar to `Hash#empty?`

- #keys : ArrayLiteral

  Similar to `Hash#keys`

- #map : ArrayLiteral

  Similar to `Hash#map`

- #of_key : ASTNode | Nop

  Returns the type specified at the end of the Hash literal, if any.

- #of_value : ASTNode | Nop

  Returns the type specified at the end of the Hash literal, if any.

- #size : NumberLiteral

  Similar to `Hash#size`

- #to_a : Crystal::Macros::ArrayLiteral(TupleLiteral)

  Similar to `Hash#to_a`

- #type : Path | Nop

  Returns the type that receives the items of the array.

- #values : ArrayLiteral

  Similar to `Hash#values`

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, line_number : StringLiteral | NilLiteral line_number, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Instance Method Detail

def [](key : ASTNode) : ASTNode #

Similar to `Hash#[]`

def []=(key : ASTNode) : ASTNode #

Similar to `Hash#[]=`

def clear : HashLiteral #

Similar to `Hash#clear`

def double_splat(trailing_string : StringLiteral = nil) : MacroId #

Returns a `MacroId` with all of this hash elements joined by commas.

If trailing_string is given, it will be appended to the result unless this hash is empty. This lets you splat a hash and optionally write a trailing comma if needed.

def empty? : BoolLiteral #

Similar to `Hash#empty?`

def keys : ArrayLiteral #

Similar to `Hash#keys`

def map : ArrayLiteral #

Similar to `Hash#map`

def of_key : ASTNode | Nop #

Returns the type specified at the end of the Hash literal, if any.

This refers to the key type after brackets in `{} of String => Int32`.

def of_value : ASTNode | Nop #

Returns the type specified at the end of the Hash literal, if any.

This refers to the value type after brackets in `{} of String => Int32`.

def size : NumberLiteral #

Similar to `Hash#size`

def to_a : Crystal::Macros::ArrayLiteral(TupleLiteral) #

Similar to `Hash#to_a`

def type : Path | Nop #

Returns the type that receives the items of the array.

This refers to the part before brackets in `MyHash{'a' => 1, 'b' => 2}`

def values : ArrayLiteral #

Similar to `Hash#values`